/**
 * Diese Klasse repraesentiert eine nxm-Matrix mit Hilfe
 * eines Arrays der Laenge n*m.
 * @author Peter Schneider-Kamp
 * @version 25.11.2003, 11:31
 */
public class Matrix {

    /**
     * Das eindimensionale Array repraesentiert Spalten
     * und Zeilen der Matrix.
     */
    private Element[] elemente;

    /**
     * Die Breite wird benoetigt, um auf das eindimensionale
     * Array sinnvoll zugreifen zu koennen.
     */
    private int breite;

    /**
     * Diese Methode setzt Breite und Hoehe dieser Matrix.
     * @param breite Breite dieser Matrix.
     * @param hoehe Hoehe dieser Matrix.
     */
    public void setDimension(int breite, int hoehe) {
        this.elemente = new Element[breite*hoehe];
        this.breite = breite;
    }

    /**
     * Diese Methode gibt die Breite dieser Matrix zurueck.
     * @return Breite dieser Matrix.
     */
    public int getWidth() {
        return this.breite;
    }

    /**
     * Diese Methode gibt die Hoehe dieser Matrix zurueck.
     * @return Hoehe dieser Matrix.
     */
    public int getHeight() {
        if (breite == 0) {
            return 0;
        } else {
            return this.elemente.length / breite;
        }
    }

    /**
     * Diese Methode liefer den wert des Elementes einer bestimmten Position.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @return Wert, den das Element an der Position x,y besitzt.
     */
    public Element getElement(int x, int y) {
        int offset = breite * y + x;
        return elemente[offset];
    }

    /**
     * Diese Methode setzt das Element an einer bestimmten Position
     * auf den gegebenen Wert.
     * @param x Spalte der Position.
     * @param y Zeile der Position.
     * @param wert Wert, den das Element an der Position x,y bekommen soll.
     */
    public void setElement(int x, int y, Element wert) {
        int offset = breite * y + x;
        elemente[offset] = wert;
    }

    /**
     * Diese Methode erstellt eine Stringdarstellung dieser Matrix.
     * @return Eine Stringdarstellung dieser Matrix.
     */
    public String toString() {
        String ausgabe = "";
        for (int j = 0; j < getHeight(); j++) {
            for (int i = 0; i < getWidth(); i++) {
                if (i > 0)
                    ausgabe += " ";
                ausgabe += getElement(i, j);
            }
            ausgabe += "\n";
        }
        return ausgabe;
    }

}
