/**
 * Diese Klasse repraesentiert ein Bit.
 * @author Peter Schneider-Kamp
 * @version 25.11.2003, 12:15
 */
public class Element {

    /**
     * Das Bit wird als Boolean gespeichert.
     */
    private boolean wert;

    /**
     * Diese Methode setzt den Wert der Klasse auf
     * das Nullelement.
     */
    public void setZero() {
        this.wert = false;
    }

    /**
     * Diese Methode berechnet die Summe von zwei Elementen.
     * Dabei wird ein neues Element erzeugt, d.h., die bergebenen
     * Elemente werden nicht gendert.
     * @param b Der zweite Summand des Summe.
     * @return Die Summe der beiden Elemente.
     */
    public Element add(Element b) {
        Element ergebnis = new Element();
        ergebnis.wert = wert != b.wert;
        return ergebnis;
    }

    /**
     * Diese Methode berechnet das Produkt von zwei Elementen.
     * Dabei wird ein neues Element erzeugt, d.h., die bergebenen
     * Elemente werden nicht gendert.
     * @param b Der zweite Multiplikand des Produktes.
     * @return Das Produkt der beiden Elemente.
     */
    public Element multiply(Element b) {
        Element ergebnis = new Element();
        ergebnis.wert = wert && b.wert;
        return ergebnis;
    }

    /**
     * Diese Methode liest ein Element ein.
     * @return Das eingelesene Element.
     */
    public static Element read() {
        Element ergebnis = new Element();
        ergebnis.wert = (IO.readInt() & 1) == 1;
        return ergebnis;
    }

    /**
     * Diese Methode erstellt eine Stringdarstellung dieses Elementes.
     * @return Eine Stringdarstellung dieses Elementes.
     */
    public String toString() {
        if (wert)
            return "1";
        else
            return "0";
    }

}
